#include <glm/ext.hpp>

#include "a4.hpp"

void a4_render(
	// What to render
	SceneNode *root,

	// Image to write to, set to a given width and height
	Image& image,

	// Viewing parameters
	const glm::vec3& eye, const glm::vec3& view,
	const glm::vec3& up, double fov,

	// Lighting parameters
	const glm::vec3& ambient,
	const std::list<Light*>& lights
)
{
  // Fill in raytracing code here.

  std::cerr << "Stub: a4_render(" << root << ",\n     "
            << "image(" << image.width() << ", " 
						<< image.height() << "),\n     "
            << glm::to_string(eye) << ", " 
			<< glm::to_string(view) << ", " 
			<< glm::to_string(up) << ", " << fov << ",\n     "
            << glm::to_string(ambient) << ",\n     {";

  for (std::list<Light*>::const_iterator I = lights.begin(); I != lights.end(); ++I) {
    if (I != lights.begin()) std::cerr << ", ";
    std::cerr << **I;
  }
  std::cerr << "});" << std::endl;
  
  size_t h = image.height();
  size_t w = image.width();

  for (size_t y = 0; y < h; ++y) {
    for (size_t x = 0; x < w; ++x) {
      // Red: increasing from top to bottom
      image(x, y, 0) = (double)y / h;
      // Green: increasing from left to right
      image(x, y, 1) = (double)x / w;
      // Blue: in lower-left and upper-right corners
      image(x, y, 2) = ((y < h/2 && x < w/2)
                      || (y >= h/2 && x >= w/2)) ? 1.0 : 0.0;
    }
  }
}
